



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C fwrite</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C fwrite</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 06:19:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums">功能：向文件读入写入一个数据块。</pre>
<p>用法：fwrite(const void *buffer,size_t size,size_t count,FILE *stream);</p>
<p>(1)buffer:是一个指针，对fwrite 来说，是要输出数据的地址。</p>
<p>(2)size:要写入内容的单字节数；</p>
<p>(3)count:要进行写入size字节的数据项的个数；</p>
<p>(4)stream:目标文件指针。</p>
<p>说明：写入到文件的哪里与文件的打开模式有关，如果是r+,则是从file pointer 指向的地址开始写，替换掉之后的内容，文件的长度可以不变，stream的位置移动count个数。如果是a+,则从文件的末尾开始添加，文件长度加大，而且是fseek函数对此函数没有作用。</p>
<p>demo1:</p>
<div>
<ol><li>#include&nbsp;&lt;stdio.h&gt;</li>
<li>#include&nbsp;&lt;process.h&gt;</li>
<li>typedef&nbsp;struct</li>
<li>{</li>
<li>int&nbsp;i;</li>
<li>char&nbsp;ch;</li>
<li>}mystruct;</li>
<li>int&nbsp;main()</li>
<li>{</li>
<li>FILE&nbsp;*stream;</li>
<li>mystruct&nbsp;s;</li>
<li>/*wb只写打开或新建一个二进制文件；只允许写数据。*/</li>
<li>if&nbsp;((stream=fopen("test.$$$","wb"))==NULL)</li>
<li>{</li>
<li>fprintf(stderr,"cannot&nbsp;open&nbsp;output&nbsp;file.\n");</li>
<li>return&nbsp;1;</li>
<li>}</li>
<li>s.i=0;</li>
<li>s.ch='A';</li>
<li>fwrite(&amp;s,sizeof(s),1,stream);</li>
<li>fclose(stream);</li>
<li>stream=NULL;</li>
<li>system("pause");</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
<pre class="prettyprint linenums">demo2:</pre>
<div>
<ol><li>#include&nbsp;&lt;stdio.h&gt;</li>
<li>int&nbsp;main()</li>
<li>{</li>
<li>FILE&nbsp;*pFile=NULL;</li>
<li>char&nbsp;buffer[]={'x','y','z'};</li>
<li>pFile=fopen("myfile.bin","wb");</li>
<li>fwrite(buffer,sizeof(buffer),1,pFile);</li>
<li>fclose(pFile);</li>
<li>system("pause");</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
<pre class="prettyprint linenums">demo3:</pre>
<div>
<ol><li>#include&nbsp;&lt;stdio.h&gt;</li>
<li>#include&nbsp;&lt;process.h&gt;</li>
<li>int&nbsp;main()</li>
<li>{</li>
<li>FILE&nbsp;*fp=NULL;</li>
<li>char&nbsp;msg[]="file&nbsp;content";</li>
<li>char&nbsp;buf[20];</li>
<li>fp=fopen("c:\\a.txt","w+");&nbsp;&nbsp;&nbsp;&nbsp;//二级目录会不成功</li>
<li>if&nbsp;(NULL==fp)</li>
<li>{</li>
<li>printf("The&nbsp;file&nbsp;doesn't&nbsp;exist!\n");</li>
<li>getchar();</li>
<li>getchar();</li>
<li>return&nbsp;-1;</li>
<li>}</li>
<li>fwrite(msg,strlen(msg),1,fp);&nbsp;&nbsp;&nbsp;//把字符串内容写入到文件</li>
<li>fseek(fp,0,SEEK_SET);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//定位文件指针到文件首位置</li>
<li>fread(buf,strlen(msg),1,fp);&nbsp;&nbsp;&nbsp;&nbsp;//把文件读入到缓存</li>
<li>buf[strlen(msg)]='\0';&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//删除缓存内多余空间</li>
<li>printf("buf=%s\n",buf);</li>
<li>printf("strlen(buf)&nbsp;=&nbsp;%d\n",strlen(buf));</li>
<li>system("pause");</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
<pre class="prettyprint linenums"></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnej2qr.html">计算机程序的思维逻辑 &lpar;31&rpar; - 剖析Arrays</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw0pgz9.html">SqlServer索引使用及维护</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2n1y3q.html">Sharepoint2013 中想要将网站另存为模板步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1e3v09.html">SU suamp命令学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1exp9.html">jqGrid&lpar;struts2&plus;jdbc&plus;jsp&rpar;增删改查的例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1vr6n9.html">7 天玩转 ASP&period;NET MVC - 第 1 天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnlm3v8.html">ccnu-线段树-单点更新3-C</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1o3wj8.html">在eclipse中创建web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0knn4q.html">工厂类分离与java反射机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvjmx8.html">【翻译】C&num;和&period;NET核心快速参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zkdx59.html">JDK的并发容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1vg08.html">centos6 网卡配置&comma;多IP设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2joek38.html">asp&period;net&sol;wingtip&sol;创建数据访问层</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e414yj9.html">今天想写一下关于SpringMVC的视图解释器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j12mn09.html">BZOJ&period;3784&period;树上的路径&lpar;点分治 贪心 堆&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4joy3eq.html">使用TestServer测试ASP&period;NET Core API</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25rm3oq.html">HierSort&lpar;希尔&rpar;&mdash;&mdash;&mdash;&mdash;Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25rv4wq.html">移动端 - APP测试要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1egz69.html">Redis 总结精讲</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2k7e08.html">在SpringTest中将Mockito的mock对象通过spring注入使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlo5g0q.html">使用bootstrap tooltip控件动态修改提示内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/495pwdeq.html">js跨域问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96my4j8.html">JavaScript创建对象及对象继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zv47d9.html">耿丹CS16-2班第一次作业汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq44640q.html">sha256 C语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qndlrg8.html">解决NSData转NSString返回nil的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77vneq.html">Win10 Migrate apps to the Universal Windows Platform &lpar;UWP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvdpn1q.html">AutoMapper搬运工之自定义类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pm5gy9.html">EventBus 一</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zvn1d9.html">linq学习笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
